import { Core } from "./Core";

let core = new Core(import.meta.env.VITE_API_URL);

class ServerAPI {
    //用户相关
    static ImageCaptcha(callback = function () { }) {
        core.request(
            "/User/ImageCaptcha",
            {},
            { method: 'GET' },
            callback
        )
    }

    static SendEmail(email, text, id, type, callback = function () { }) {
        core.request(
            "/User/SendEmail",
            { email, text, id, type },
            { method: 'POST' },
            callback
        )
    }

    static Register(username, email, code, password, callback = function () { }) {
        core.request(
            "/User/Register",
            { username, email, code, password },
            { method: 'POST' },
            callback
        )
    }

    static ForgetPassword(username, email, code, password, callback = function () { }) {
        core.request(
            "/User/ForgetPassword",
            { username, email, code, password },
            { method: 'POST' },
            callback
        )
    }

    static Login(username, password, text, id, callback = function () { }) {
        core.request(
            "/User/Login",
            { username, password, text, id },
            { method: 'POST' },
            callback
        )
    }

    static WXWorkUrl(num, type, callback = function () { }) {
        core.request(
            "/User/WXWorkUrl",
            {
                num,
                type
            },
            { method: 'GET' },
            callback
        )
    }

    static WXWorkLogin(code, callback = function () { }) {
        core.request(
            "/User/WXWorkLogin",
            {
                code
            },
            { method: 'POST' },
            callback
        )
    }

    static UpdateInfo(uuid, session, code, callback = function () { }) {
        core.request(
            "/User/UpdateInfo",
            {
                uuid,
                session,
                code
            },
            { method: 'POST' },
            callback
        )
    }

    static getPermissions(uuid, session, callback = function () { }) {
        core.request(
            "/User/GetPermissions",
            {
                uuid,
                session
            },
            { method: 'GET' },
            callback
        )
    }

    static checkLoginSession(uuid, session, callback = function () { }) {
        core.request(
            "/User/CheckLoginSession",
            {
                uuid,
                session
            },
            { method: 'GET' },
            callback
        )
    }

    //考勤相关
    static GetAttendanceItemList(uuid, session, callback = function () { }) {
        core.request(
            "/Attendance",
            {
                uuid,
                session
            },
            { method: 'GET' },
            callback
        )
    }

    static DeleteAttendanceItem(uuid, session, id, callback = function () { }) {
        core.request(
            "/Attendance",
            {
                uuid,
                session,
                project_id: id
            },
            { method: 'DELETE' },
            callback
        )
    }

    static AddAttendanceItems(data, callback = function () { }) {
        core.request(
            "/Attendance",
            data,
            { method: 'POST' },
            callback
        )
    }

    static EditAttendanceItems(data, callback = function () { }) {
        core.request(
            "/Attendance",
            data,
            { method: 'PUT' },
            callback
        )
    }

    static GetMyAttendanceItems(uuid, session, callback = function () { }) {
        core.request(
            "/GetMyAttendanceItems",
            {
                uuid,
                session
            },
            { method: 'GET' },
            callback
        )
    }

    static GetAttendanceItemDetail(uuid, session, id, callback = function () { }) {
        core.request(
            "/GetAttendanceItemDetail",
            { uuid, session, project_id: id },
            { method: 'GET' },
            callback
        )
    }

    static AddAttendanceRecord(uuid, session, id, callback = function () { }) {
        core.request(
            "/AddAttendanceRecord",
            { uuid, session, project_id: id },
            { method: 'GET' },
            callback
        )
    }

    static SupplementRecord(uuid, session, user, id, callback = function () { }) {
        core.request(
            "/SupplementRecord",
            { uuid, session, user, project_id: id },
            { method: 'GET' },
            callback
        )
    }

    //网站管理
    static UserList(uuid, session, callback = function () { }) {
        core.request(
            "/Admin/User",
            {
                uuid,
                session
            },
            { method: 'GET' },
            callback
        )
    }

    static SetPermission(uuid, session, userid, manage, callback = function () { }) {
        core.request(
            "/Admin/SetPermission",
            {
                uuid,
                session,
                userid,
                manage
            },
            { method: 'POST' },
            callback
        )
    }
}

export {
    ServerAPI
}